# Retrieve a product by key Retrieves detailed information about a specific product by its unique product number or ID. You can optionally specify related objects to expand in the request body. Endpoint: POST /commerce/products/{product_key} Version: 2026-02-20 Security: bearerAuth ## Header parameters: - `Accept-Encoding` (string) Include the Accept-Encoding: gzip header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response. If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a Content-Encoding header with the compression algorithm so that your client can decompress it. - `Content-Encoding` (string) Include the Content-Encoding: gzip header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload. - `Zuora-Track-Id` (string) A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue. The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (:), semicolon (;), double quote ("), and quote ('). - `Zuora-Entity-Ids` (string) An entity ID. If you have Zuora Multi-entity enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header. - `Zuora-Org-Ids` (string) Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header. The IDs must be a sub-set of the user's accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user's accessible orgs. ## Path parameters: - `product_key` (string, required) The unique number or ID of the product to be retrieved. ## Request fields (application/json): - `expand` (object) Controls which related objects are expanded and included in the response. - `expand.productRatePlans` (boolean) When true, includes product rate plans in the response. - `expand.productRatePlanCharges` (boolean) When true, includes product rate plan charges in the response. - `expand.businessContextFilters` (boolean) When true, includes business context filters in the response. ## Response 200 fields (application/json): - `allowFeatureChanges` (boolean) - `category` (string) Product category, for example base or add_on. Example: "base" - `contextFilters` (array) Example: [] - `createdBy` (string) ID of the user who created the product. Example: "53c162482f054f3ca08e1ec82dccfec9" - `createdTime` (string) Example: "2025-10-13T07:44:55.000-07:00" - `customFields` (object) Custom field values keyed by API name. Example: {} - `customObjects` (object,null) Custom object references related to this product. - `dacTag` (object) Internal DAC tag associated with the product. Example: {"id":"1234567890abcdef","name":"Example DAC Tag"} - `dacTag.id` (string) DAC tag identifier. Example: "1234567890abcdef" - `dacTag.name` (string) DAC tag name. Example: "Example DAC Tag" - `endDate` (string) Product effective end date. Example: "2050-12-31" - `features` (array) Example: [] - `id` (string) Unique identifier of the product. Example: "7228c9e6fd814e3a9e59bcdf0117e34f" - `legacyFeatures` (array) Legacy, customer-defined feature objects retained for compatibility. Example: [] - `name` (string) Product name. Example: "New prod" - `netsuite` (object,null) NetSuite integration metadata if applicable. - `organizationLabels` (array) Example: [] - `productNumber` (string) System-generated product number. Example: "PC-00000103" - `productRatePlans` (array) List of rate plans under this product. Example: [{"id":"38660706ef2f48cfb5222f7dde491895","createdBy":"53c162482f054f3ca08e1ec82dccfec9","createTime":"2025-02-24T01:21:23.000+00:00","updatedBy":"53c162482f054f3ca08e1ec82dccfec9","updateTime":"2025-02-24T01:21:23.000+00:00","name":"Bronze Plan","displayName":"Bronze Plan","description":"Basic version of our software service","productId":"7228c9e6fd814e3a9e59bcdf0117e34f","startDate":"2025-09-10","endDate":"2027-01-01","state":"active","status":"ACTIVE","activeCurrencies":["USD"],"productRatePlanNumber":"PRP-00000172","productRatePlanCharges":[{"id":"fe9b0e764dca4178a11c0e471e5dc0d8","productRatePlanChargeNumber":"PRPC-00000279","name":"prepay_currency","description":"Prepaid recurring software fee","chargeType":"recurring","chargeModel":"flat_fee","listPriceBase":"Per_Billing_Period","specificListPriceBase":1,"triggerEvent":"contract_effective","endDateCondition":"subscription_end","upToPeriodsType":"billing_periods","upToPeriods":1,"billCycle":{"period":"bill_cycle_period_quarter","periodAlignment":"align_to_term_start","timing":"in_advance","type":"term_start_day"},"pricing":{"flatAmounts":{"USD":30},"tiers":[]},"pricingSummary":["USD30"],"taxMode":"non_taxable","taxable":false,"createdById":"53c162482f054f3ca08e1ec82dccfec9","createdTime":"2025-02-24T01:21:23.000+00:00","updatedById":"53c162482f054f3ca08e1ec82dccfec9","updatedTime":"2025-02-24T01:21:23.000+00:00"}]}] - `productRatePlans.id` (string) Unique identifier of the Product Rate Plan. Example: "38660706ef2f48cfb5222f7dde491895" - `productRatePlans.createdBy` (string) ID of the user who created the rate plan. Example: "53c162482f054f3ca08e1ec82dccfec9" - `productRatePlans.createTime` (string) Timestamp when the rate plan was created. Example: "2025-02-24T01:21:23.000+00:00" - `productRatePlans.updatedBy` (string) ID of the user who last updated the rate plan. Example: "53c162482f054f3ca08e1ec82dccfec9" - `productRatePlans.updateTime` (string) Timestamp when the rate plan was last updated. Example: "2025-02-24T01:21:23.000+00:00" - `productRatePlans.name` (string) Product Rate Plan name. Example: "Bronze Plan" - `productRatePlans.displayName` (string) Product Rate Plan display name. Example: "Bronze Plan" - `productRatePlans.description` (string) Product Rate Plan description. Example: "Basic version of our software service" - `productRatePlans.productId` (string) Identifier of the product this plan belongs to. Example: "7228c9e6fd814e3a9e59bcdf0117e34f" - `productRatePlans.startDate` (string) Effective start date of the plan (UTC, YYYY-MM-DD). Example: "2025-09-10" - `productRatePlans.endDate` (string) Effective end date of the plan (UTC, YYYY-MM-DD). Example: "2027-01-01" - `productRatePlans.state` (string) Current plan state. Example: "active" - `productRatePlans.status` (string) Status of the plan. Example: "ACTIVE" - `productRatePlans.activeCurrencies` (array) Currencies supported by this plan. Example: ["USD"] - `productRatePlans.productRatePlanNumber` (string) Product Rate Plan number. Example: "PRP-00000172" - `productRatePlans.productRatePlanCharges` (array) List of Product Rate Plan Charges (PRPCs) belonging to the plan. - `productRatePlans.productRatePlanCharges.id` (string) Unique identifier of the Product Rate Plan Charge. Example: "fe9b0e764dca4178a11c0e471e5dc0d8" - `productRatePlans.productRatePlanCharges.productRatePlanChargeNumber` (string) System-generated number of the Product Rate Plan Charge. Example: "PRPC-00000279" - `productRatePlans.productRatePlanCharges.name` (string) Charge name. Example: "prepay_currency" - `productRatePlans.productRatePlanCharges.description` (string) Charge description. Example: "Prepaid recurring software fee" - `productRatePlans.productRatePlanCharges.chargeType` (string) Charge type (recurring, one_time, or usage). Example: "recurring" - `productRatePlans.productRatePlanCharges.chargeModel` (string) Charge model (flat_fee, per_unit, tiered, etc.). Example: "flat_fee" - `productRatePlans.productRatePlanCharges.listPriceBase` (string) Indicates how list price is interpreted. Example: "Per_Billing_Period" - `productRatePlans.productRatePlanCharges.specificListPriceBase` (integer) Specifies the number of periods for list price when listPriceBase is period-based. Example: 1 - `productRatePlans.productRatePlanCharges.triggerEvent` (string) Event that triggers the charge. Example: "contract_effective" - `productRatePlans.productRatePlanCharges.endDateCondition` (string) Condition that determines when the charge ends. Example: "subscription_end" - `productRatePlans.productRatePlanCharges.upToPeriodsType` (string) Type of period used with upToPeriods to control charge duration. Example: "billing_periods" - `productRatePlans.productRatePlanCharges.upToPeriods` (integer) Number of periods after which the charge ends, based on upToPeriodsType. Example: 1 - `productRatePlans.productRatePlanCharges.billCycle` (object) Billing cycle configuration. Example: {"period":"bill_cycle_period_quarter","periodAlignment":"align_to_term_start","timing":"in_advance","type":"term_start_day"} - `productRatePlans.productRatePlanCharges.pricing` (object) Pricing configuration for the charge. Example: {"flatAmounts":{"USD":30},"tiers":[]} - `productRatePlans.productRatePlanCharges.pricingSummary` (array) Human-readable pricing summary lines. Example: ["USD30"] - `productRatePlans.productRatePlanCharges.taxMode` (string) Tax mode for this charge. Example: "non_taxable" - `productRatePlans.productRatePlanCharges.taxable` (boolean) Indicates whether the charge is taxable. - `productRatePlans.productRatePlanCharges.createdById` (string) ID of the user who created the charge. Example: "53c162482f054f3ca08e1ec82dccfec9" - `productRatePlans.productRatePlanCharges.createdTime` (string) Timestamp when the charge was created. Example: "2025-02-24T01:21:23.000+00:00" - `productRatePlans.productRatePlanCharges.updatedById` (string) ID of the user who last updated the charge. Example: "53c162482f054f3ca08e1ec82dccfec9" - `productRatePlans.productRatePlanCharges.updatedTime` (string) Timestamp when the charge was last updated. Example: "2025-02-24T01:21:23.000+00:00" - `sku` (string) Stock keeping unit for the product. Example: "SKU-00000133" - `startDate` (string) Product effective start date. Example: "2024-01-01" - `state` (string) Current product state. Example: "product_active" - `updatedBy` (string) ID of the user who last updated the product. Example: "53c162482f054f3ca08e1ec82dccfec9" - `updatedTime` (string) Timestamp of the last update. Example: "2025-10-13T07:44:55.000-07:00" ## Response 500 fields (application/json): - `reasons` (array) Example: [{"code":"ObjectNotFound","message":"Notification definition with id 6e569e1e05f040eda51a927b140c0ac1 does not exist"}] - `reasons.code` (string) The error code of response. - `reasons.message` (string) The detail information of the error response ## Response 4XX fields (application/json): - `processId` (string) The ID of the process that handles the operation. - `reasons` (array) The container of the error code and message. This field is available only if the success field is false. - `reasons.code` (string) The error code of response. - `reasons.message` (string) The detail information of the error response - `requestId` (string) Unique identifier of the request. - `success` (boolean) Indicates whether the call succeeded.